mount_vfs_model_path	(current_mod_path.."/Shapes")
mount_vfs_texture_path  (current_mod_path.."/Textures/B-29")

AN_M64_12 = 
{
	CLSID        = "AN_M64_12",
	category     = CAT_BOMBS,
	Picture	=	"M64.png",
	attribute	=	{4,	5,	9,	90},
	displayName	=	_("12 AN-M64"),
	Count	=	12,
	Weight	=	2724,
	Elements	=	
	{
		[1]	=	
		{
			Position	=	{0,	0,	0},
			ShapeName	=	"AN-M64",
		}, 
	}, -- end of Elements
}
declare_loadout(AN_M64_12)

B_29 = 
{
	Name 				=   'B-29',
	DisplayName			= _('B-29'),
--	HumanCockpit 		= false,
	Picture 			= current_mod_path.."/B-29.png",
	Rate 				= 40, -- RewardPoint in Multiplayer
	Shape 				= "B-29",
	shape_table_data 	= 
	{
		{
			file  	 = 'B-29';
			life  	 = 18; -- lifebar
			vis   	 = 3; -- visibility gain.
			desrt    = 'B-29_destr'; -- Name of destroyed object file name
			fire  	 = { 300, 2}; -- Fire on the ground after destoyed: 300sec 2m
			username = 'B-29';
			index    =  WSTYPE_PLACEHOLDER;
			classname 	= "lLandPlane";
			positioning = "BYNORMAL";
			drawonmap 	= true;
		},
		{
			name  = "B-29_destr";
			file  = "B-29-destr";
			fire  = { 240, 2};
		},

	},
	mapclasskey = "P0091000027",
	attribute  			= {wsType_Air, wsType_Airplane, wsType_Intruder, WSTYPE_PLACEHOLDER , "Strategic bombers"},
	Categories 			= {},

	-------------------------
	M_empty 					= 32400, -- kg
	M_nominal 					= 62000, -- kg
	M_max 						= 64000, -- kg
	M_fuel_max 					= 19900, -- kg
	length 						= 30.2, -- full lenght in m
	height 						= 8.5, -- height in m
	wing_area 					= 151.0, -- wing area in m2
	wing_span 					= 43.1, -- wing spain in m
	wing_type 					= 0,
	wing_tip_pos 				=  {0.908,	1.636, 21.415}, -- wingtip coords for visual effects
	nose_gear_pos 				= {12.448,	-2.587,	0}, -- nosegear coord
	main_gear_pos 				= {1.993,	-2.587,	4.503}, -- main gear coords
	tand_gear_max 				= 0.577,
	nose_gear_wheel_diameter 	= 0.793, -- in m
	main_gear_wheel_diameter 	= 1.395, -- in m
	stores_number				=	0,
	V_opt 						= 208,-- Cruise speed (for AI)
	V_take_off 					= 80, -- Take off speed in m/s (for AI) 288km/h
	V_land 						= 75, -- Land speed in m/s (for AI)
	V_max_sea_level 			= 140, -- Max speed at sea level in m/s (for AI)
	V_max_h 					= 160, -- Max speed at max altitude in m/s (for AI)
	Vy_max 						= 2.68, -- Max climb speed in m/s (for AI)
	Mach_max 					= 0.53, -- Max speed in Mach (for AI)
	H_max 					 	= 9720, -- m
	Ny_min 						= 0, -- Min G (for AI)
	Ny_max 						= 2.5,  -- Max G (for AI)
	Ny_max_e 					= 2,  -- Max G (for AI)
	AOA_take_off 				= 0.14, -- AoA in take off (for AI)
	bank_angle_max 				= 45, -- Max bank angle (for AI)
	average_fuel_consumption 	= 0.2527, -- this is highly relative, but good estimates are 36-40l/min = 28-31kg/min = 0.47-0.52kg/s -- 45l/min = 35kg/min = 0.583kg/s
	range 						= 6600, -- Max range in km (for AI)
	CAS_min 					= 72, -- if this is not OVERAL FLIGHT TIME, but jus LOITER TIME, than it sholud be 10-15 minutes.....CAS capability in minute (for AI)
	thrust_sum_max 				= 50000,
	thrust_sum_ab 				= 50000,
	has_afteburner 				= false, -- AFB yes/no
	has_speedbrake 				= false, -- Speedbrake yes/no
	tanker_type 				= 0, -- Tanker type if the plane is airrefuel capable
	flaps_maneuver 				= 0.5, -- Max flaps in take-off and maneuver (0.5 = 1st stage; 1.0 = 2nd stage) (for AI)
	brakeshute_name 			= 0, -- Landing - brake chute visual shape after separation
	is_tanker 					= false, -- Tanker yes/no
	air_refuel_receptacle_pos 	= {0, 0, 0}, -- refuel coords
	RCS 						= 100, -- Radar Cross Section m2
	IR_emission_coeff 			= 1.5, -- Normal engine -- IR_emission_coeff = 1 is Su-27 without afterburner. It is reference.
	IR_emission_coeff_ab 		= 0, -- With afterburner
	engines_count				= 4, -- Engines count
	engines_nozzles = 
	{
		[1] = 
		{
			pos 		=  {4.522,	0.584,	-9.834}, -- nozzle coords
			elevation   =  0, -- AFB cone elevation
			diameter	 = 1.523, -- AFB cone diameter
			exhaust_length_ab	=	11.794,
			exhaust_length_ab_K	=	0.76,
		},
		[2] = 
		{
			pos 		=  {4.522,	0,	-4.578}, -- nozzle coords
			elevation   =  0, -- AFB cone elevation
			diameter	 = 1.523, -- AFB cone diameter
			exhaust_length_ab	=	11.794,
			exhaust_length_ab_K	=	0.76,
		},
		[3] = 
		{
			pos 		=  {4.522,	0,	4.578}, -- nozzle coords
			elevation   =  0, -- AFB cone elevation
			diameter	 = 1.523, -- AFB cone diameter
			exhaust_length_ab	=	11.794,
			exhaust_length_ab_K	=	0.76,
		},
		[4] = 
		{
			pos 		=  {4.522,	0.584,	9.834}, -- nozzle coords
			elevation   =  0, -- AFB cone elevation
			diameter	 = 1.523, -- AFB cone diameter
			exhaust_length_ab	=	11.794,
			exhaust_length_ab_K	=	0.76,
		},
	}, -- end of engines_nozzles

	crew_size	 = 11,
	crew_members = 
	{
		[1] = 
		{
			pilot_name			= 0,
			ejection_seat_name	= 0,
			drop_canopy_name	= 0,
			pos					= {0, 0, 0},
			canopy_pos			= {0, 0, 0},
		}, -- end of [1]
	}, -- end of crew_members

	fires_pos = 
	{
		[1] = 	{3.028,	0.0,	0},
		[2] = 	{5.322,	0.0,	2.002},
		[3] = 	{5.322,	0.0,	-2.002},
		[4] = 	{2.724,	0.291,	2.703},
		[5] = 	{2.724,	0.291,	-2.703},
		[6] = 	{3.909,	0.081,	2.580},
		[7] = 	{3.909,	0.081,	-2.580},
		[8] = 	{6.799,	0.0,	4.304},
		[9] = 	{6.799,	0.0,	-4.304},
		[10] = 	{6.321,	0.443,	9.482},
		[11] = 	{6.321,	0.443,	-9.482},
	}, -- end of fires_pos
	
	-- Countermeasures
	SingleChargeTotal	 	= 0,
	CMDS_Incrementation 	= 0,
	ChaffDefault 			= 0, 
	ChaffChargeSize 		= 0,
	FlareDefault 			= 0, 
	FlareChargeSize 		= 0,
	CMDS_Edit 				= false,
	chaff_flare_dispenser 	= 
	{
	}, -- end of chaff_flare_dispenser

	--sensors
	
	detection_range_max		 = 60,
	radar_can_see_ground 	 = false, -- this should be examined (what is this exactly?)
	CanopyGeometry = 
	{
		azimuth   = {-160.0, 160.0}, -- pilot view horizontal (AI)
		elevation = {-50.0, 90.0} -- pilot view vertical (AI)
	},
	Sensors = 
	{
	},
	HumanRadio = 
	{
		frequency = 127.5,  -- Radio Freq
		editable = true,
		minFrequency = 100.000,
		maxFrequency = 156.000,
		modulation = MODULATION_AM
	},

	Guns = 
	{
		gun_mount("M_2",
			{count = 1000},
			{muzzle_pos = {11.67, 1.57, 0.0},
			 supply_position = {11.67, 1.57, 0.0},
			 aft_gun_mount = true,
			}
		),
		gun_mount("M_2",
			{count = 1000},
			{muzzle_pos = {11.3, -1.57, 0.0},
			 supply_position = {11.3, -1.57, 0.0},
			 aft_gun_mount = true,
			}
		),
		gun_mount("M_2",
			{count = 1000},
			{muzzle_pos = {-3.16, 1.57, 0.0},
			 supply_position = {-3.16, 1.57, 0.0},
			 aft_gun_mount = true,
			}
		),
		gun_mount("M_2",
			{count = 1000},
			{muzzle_pos = {-8.77, -0.56, 0.0},
			 supply_position = {-8.77, -0.56, 0.0},
			 aft_gun_mount = true,
			}
		),
		gun_mount("M_2",
			{count = 1000},
			{muzzle_pos = {-14.48, 0.99, 0.0},
			 supply_position = {-14.48, 0.99, 0.0},
			 aft_gun_mount = true,
			}
		),
	},
	
	Pylons = 
    {
		-- Parameter 2 = Internal or External pylon, so if its set to 2 it fires the Argument #26
        pylon(1, 2, 7.7, -0.5, 0,
            {
            },
            {
				{ CLSID = "AN_M64_12" },
            }
        ),
        pylon(2, 2, 1.8, -0.5, 0,
            {
            },
            {
				{ CLSID = "AN_M64_12" },
            }
        ),
    },

	Tasks = 
	{
		aircraft_task(GroundAttack),
		aircraft_task(RunwayAttack),
    },	
	DefaultTask = aircraft_task(RunwayAttack),

	SFM_Data = {
		aerodynamics = -- Cx = Cx_0 + Cy^2*B2 +Cy^4*B4
		{
			Cy0			=	0.2,  -- zero AoA lift coefficient
			Mzalfa		=	6.6,  -- coefficients for pitch agility
			Mzalfadt	=	1,    -- coefficients for pitch agility
			kjx			=	2.0,    
			kjz			=	0.00125, 
			Czbe		=	-0.012, -- coefficient, along Z axis (perpendicular), affects yaw, negative value means force orientation in FC coordinate system
			cx_gear		=	0.015,    -- coefficient, drag, gear
			cx_flap		=	0.05,   -- coefficient, drag, full flaps
			cy_flap		=	1.2,    -- coefficient, normal force, lift, flaps
			cx_brk		=	0.06,   -- coefficient, drag, breaks
			table_data  = 
			{
			--   M		Cx0		Cya		B		B4			Omxmax	Aldop	Cymax
				{0,		0.024,	0.1,	0.0426,	1e-006,	0.5,	20,	1.2},
				{0.1,	0.024,	0.1,	0.0426,	1e-006,	1,		20,	1.2},
				{0.2,	0.024,	0.1,	0.0426,	1e-006,	1.5,	20,	1.2},
				{0.3,	0.024,	0.1,	0.0426,	1e-006,	2,		20,	1.2},
				{0.4,	0.024,	0.1,	0.0426,	1e-006,	2.5,	20,	1.2},
				{0.5,	0.024,	0.1,	0.0426,	1e-006,	3,		20,	1.2},
				{0.6,	0.024,	0.1,	0.044,	1e-006,	3.5,	20,	1.2},
				{0.7,	0.025,	0.1,	0.045,	0.02,	3.5,	20,	1},
				{0.8,	0.029,	0.1,	0.049,	0.05,	3.5,	20,	0.9},
				{0.9,	0.04,	0.1,	0.071,	0.07,	3.5,	20,	0.8},
				{1,		0.06,	0.1,	0.138,	0.2,	3.5,	20,	0.76666666666667},
			}, -- end of table_data
			-- M - Mach number
			-- Cx0 - Coefficient, drag, profile, of the airplane
			-- Cya - Normal force coefficient of the wing and body of the aircraft in the normal direction to that of flight. Inversely proportional to the available G-loading at any Mach value. (lower the Cya value, higher G available) per 1 degree AOA
			-- B - Polar quad coeff
			-- B4 - Polar 4th power coeff
			-- Omxmax - roll rate, rad/s
			-- Aldop - Alfadop Max AOA at current M - departure threshold
			-- Cymax - Coefficient, lift, maximum possible (ignores other calculations if current Cy > Cymax)
		}, -- end of aerodynamics
		engine = 
		{
			Nmg	=	67.5, -- RPM at idle
			MinRUD	=	0, -- Min state of the throttle
			MaxRUD	=	1, -- Max state of the throttle
			MaksRUD	=	1, -- Military power state of the throttle
			ForsRUD	=	1, -- Afterburner state of the throttle
			typeng	=	2,
			--	E_TURBOJET = 0
			--	E_TURBOJET_AB = 1
			--	E_PISTON = 2
			--	E_TURBOPROP = 3
			--	E_TURBOFAN	= 4
			--	E_TURBOSHAFT = 5
			hMaxEng	=	19.5, -- Max altitude for safe engine operation in km
			dcx_eng	=	0.0085, -- Engine drag coeficient
			cemax	=	0.37, -- not used for fuel calulation , only for AI routines to check flight time ( fuel calculation algorithm is built in )
			cefor	=	0.37, -- not used for fuel calulation , only for AI routines to check flight time ( fuel calculation algorithm is built in )
			dpdh_m	=	19000, --  altitude coefficient for max thrust
			dpdh_f	=	19000, --  altitude coefficient for AB thrust
			table_data = 
			{
			--   M		Pmax		 Pfor	
				{0,		608000,	608000},
				{0.1,	568000,	568000},
				{0.2,	520000,	520000},
				{0.3,	484000,	484000},
				{0.4,	440000,	440000},
				{0.5,	418000,	418000},
				{0.6,	410000,	410000},
				{0.7,	436000,	436000},
				{0.798,	470000,	470000},
				{0.9,	524000,	524000},
				{1,		560000,	560000},
			}, -- end of table_data
			-- M - Mach number
			-- Pmax - Engine thrust at military power
			-- Pfor - Engine thrust at AFB
			k_adiab_1			= 0.037923,
			k_adiab_2			= 0.0562,
			MAX_Manifold_P_1	= 155774,
			MAX_Manifold_P_2	= 206570,
			MAX_Manifold_P_3	= 226648,
			k_after_cool		= 0.54,
			Displ				= 27,
			k_Eps				= 6,
			Stroke				= 0.152,
			V_pist_0			= 12,
			Nu_0				= 15.0,
			Nu_1				= 2.4,
			Nu_2				= 0.001,
			N_indic_0			= 1023040,
			N_fr_0				= 0.072,
			N_fr_1				= 0.02,
			Init_Mom			= 220,
			D_prop				= 3.45,
			MOI_prop			= 65,
			k_gearbox			= 2.088,
			P_oil				= 495438,
			k_boost				= 3,
			k_cfug				= 0.003,
			k_oil				= 0.00004,
			k_piston			= 3000,
			k_reg				= 0.003,
			k_vel				= 0.017,
		}, -- end of engine
	}, -- end of SFM_Data

	--damage , index meaning see in  Scripts\Aircrafts\_Common\Damage.lua
	Damage = 
	{
		[3]  = {critical_damage = 20,args = {65}}, 	--"COCKPIT"
		[4]  = {critical_damage = 5, args = {150}},	--"CABIN_LEFT_SIDE"
		[5]  = {critical_damage = 5, args = {147}},	--"CABIN_RIGHT_SIDE"
		[6]  = {critical_damage = 5, args = {152}},	--"CABIN_BOTTOM"
		[9]  = {critical_damage = 3, args = {148}},	--"FUSELAGE_LEFT_SIDE"
		[10] = {critical_damage = 3, args = {149}},	--"FUSELAGE_RIGHT_SIDE"
		[11] = {critical_damage = 3, args = {167}, droppable = false},	--"ENGINE_L"
		[12] = {critical_damage = 3, args = {161}, droppable = false},	--"ENGINE_R"
		[17] = {critical_damage = 3, args = {162}, droppable = false},	--"MTG_L"
		[18] = {critical_damage = 3, args = {163}, droppable = false},	--"MTG_R"
		[23] = {critical_damage = 8, args = {223}, deps_cells = {25}, droppable = false},	--"WING_L_OUT"
		[24] = {critical_damage = 8, args = {213}, deps_cells = {26}, droppable = false},	--"WING_R_OUT"
		[25] = {critical_damage = 3, args = {226}, droppable = false},	--"ELERON_L"
		[26] = {critical_damage = 3, args = {216}, droppable = false},	--"ELERON_R"
		[29] = {critical_damage = 9, args = {224}, deps_cells = {23, 17}, droppable = false},	--"WING_L_CENTER"
		[30] = {critical_damage = 9, args = {214}, deps_cells = {24, 18}, droppable = false},	--"WING_R_CENTER"
		[35] = {critical_damage = 20, args = {225}, deps_cells = {29, 11, 37}},	--"WING_L_IN"
		[36] = {critical_damage = 20, args = {215}, deps_cells = {30, 12, 38}}, --"WING_R_IN"
		[37] = {critical_damage = 4, args = {227}, droppable = false}, --"FLAP_L"
		[38] = {critical_damage = 4, args = {217}, droppable = false}, --"FLAP_R"
		[43] = {critical_damage = 9, args = {142}, deps_cells = {53}},	--"FIN_L_BOTTOM"
		[47] = {critical_damage = 5, args = {236}, deps_cells = {51}},	--"STABILIZER_L_IN"
		[48] = {critical_damage = 5, args = {234}, deps_cells = {52}},	--"STABILIZER_R_IN"
		[51] = {critical_damage = 3, args = {240}},	--"ELEVATOR_L_IN"
		[52] = {critical_damage = 3, args = {237}},	--"ELEVATOR_R_IN"
		[53] = {critical_damage = 3, args = {248}},	--"RUDDER_L"
		[55] = {critical_damage = 3, args = {159}},	--"TAIL"
		[56] = {critical_damage = 3, args = {141}},	--"TAIL_LEFT_SIDE"
		[57] = {critical_damage = 3, args = {140}},	--"TAIL_RIGHT_SIDE"
		[82] = {critical_damage = 3, args = {153}},	--"FUSELAGE_BOTTOM"
	},  -- end of Damage
	
	DamageParts = 
	{  
		[1] = "B-29-OBLOMOK-WING-R",
		[2] = "B-29-OBLOMOK-WING-L",
	},

	lights_data = 
	{
		typename = "collection",
		lights = 
		{
			[1] = -- Xg{Cg
			{
			},
			[2] = -- fBOCg
			{
			},
		    [3]	= -- irQ[VCg
			{
		    	typename = "collection",
				lights =
				{
					-- Left Position Light (red)
					{typename = "omnilight",
					color = {0.32, 0.0, 0.07},
					position  = {3.74, 1.44, -21.45},
					argument  = 190
					},
					-- Right Position Light (green)
					{typename = "omnilight",
					color = {0, 0.26, 0.18},
					position = {3.74, 1.44, 21.45},
					argument  = 191
					},
					-- Tail Position Light (white)
					{typename = "omnilight",
					color = {0.8, 0.8, 0.8},
					position  = {-13.2, 0.33, 0.0},
					argument  = 203
					},
				}
			},
		    [4] = -- tH[[VCg
			{
			},
			[5]	=
			{
			}
		}
	},  -- end of lights_data

}

add_aircraft(B_29)
